//----------------------------------------------------------------------------------
// tH[}bgϊpXbh
// Copyright (c) 2007  N099
//----------------------------------------------------------------------------------
#pragma once

// ϊ^Cv
enum CNV_TYPE {
	PYC_YUY2 = 0,
	PYC_YUY2S,
	PYC_NV12,
	PYC_NV12S,
	YUY2_PYC,
	YUY2S_PYC,
	RGB32_PYC,
	RGB32S_PYC,
	EXIT_CNV //ϊI(exit thread)
};

// ϊp[^
struct CNV_PARAM {
	CNV_TYPE type;
	bool top; //ΏۃtB[h
	void *inPtr;
	void *outPtr;
	int h;
	int w;
	int inStride;
	int outStride; //TCY֘Aׂ͂ăsNZP
};

// [J[Xbh
class CConvThread {
private:
	HANDLE m_thread;
	HANDLE m_reqEvt;
	HANDLE m_finEvt;
	int m_thIdx; //Xbhʂԍ
	int m_thNum; //SXbh
	CNV_PARAM *m_pParam;
	bool m_sse2;

	CConvThread(const CConvThread &r);
	CConvThread &operator==(const CConvThread &r);

public:
	CConvThread();
	~CConvThread();

	bool Create(HANDLE reqEvt, HANDLE finEvt, CNV_PARAM *pp, bool sse2=false, int idx=0, int num=1);
	bool Close(void);

	DWORD ThreadProc(void);
	DWORD ThreadProcSSE2(void);

	static DWORD WINAPI InitialThreadProc(LPVOID p);
};

// tH[}bgϊ/XbhǗ
class CConv {
private:
	int m_nWorkers;
	CConvThread *m_workers;
	HANDLE *m_pReqEvt;
	HANDLE *m_pFinEvt;
	CNV_PARAM m_param;
	bool m_sse2;
	bool m_processing; //

	CConv(const CConv &r);
	CConv &operator==(const CConv &r);

public:
	CConv();
	~CConv();

	//֐̓XbhZ[tł͂Ȃ

	bool Create(int nWorkers=1, bool sse2=false);
	bool Close(void);
	bool Request(const CNV_PARAM *pp);
	bool Wait();
};
